; File Name   :	d:\hobby3\z9001-devices\v24g\K6320G.KCC
; Format      :	Binary file
; Base Address:	0000h Range: B480h - BA00h Loaded length: 0580h


; Grafikfhiger Druckertreiber
; Anschluss ber PIO

		cpu	z80

PIOAD		EQU	20H		; PIO A Daten 		Ausgabe
PIOBD		EQU	21H		; PIO B Daten 		bit0=in status
PIOAS		EQU	22H		; PIO A Kommando
PIOBS		EQU	23H		; PIO B Kommando 


		org 0B500h

;------------------------------------------------------------------------------
; OS-Rahmen
;------------------------------------------------------------------------------
		
		jp	init
name:		db "K6320G  ",0

;------------------------------------------------------------------------------
; Initialisierung
;------------------------------------------------------------------------------

init:		; PIO
		ld	a, 0Fh		; Mode 0 Byte-Ausgabe 
		out	(PIOAS), a
		ld	a, 7		; kein Interrupt
		out	(PIOAS), a
		ld	a, 0CFh		; Mode 3 Bit-E/A
		out	(PIOBS), a
		ld	a, 0Fh		; Bit 0..3 = Eingabe
		out	(PIOBS), a
		ld	a, 7		; kein Interrupt
		out	(PIOBS), a
		ld	a, 3		; Interrupt aus
		out	(PIOBS), a
;
		ld	hl, name	; "K6320G  "
		ld	bc, ttyl1
		ld	(0EFEFh), hl
		ld	(0EFE1h), bc
		ld	a, (4)
		and	3Fh
		ld	(4), a
		ld	hl, initc

;------------------------------------------------------------------------------
; Ausgabe (B) Zeichen
;------------------------------------------------------------------------------

DOUTS5:		ld	b, 5
;
DOUTS:		ld	c, (hl)
		push	bc
		call	DOUT
		pop	bc
		inc	hl
		djnz	DOUTS
		ret

;------------------------------------------------------------------------------
; Gerte-Treiber
;------------------------------------------------------------------------------

ttyl1:		ld	a, c
		cp	0Eh
		jr	nz, COUT
;
;CTRL/N Bildschirmkopie
		ld	bc, 3C0h
		ld	hl, 0EC00h
		ld	d, 40
ttyl2:		ld	a, (hl)
		push	bc
		cp	' '
		jr	nc, ttyl3
		ld	a, ' '
ttyl3:		ld	c, a
		push	hl
		call	COUT
		pop	hl
		pop	bc
		dec	d
		jr	nz, ttyl4
		push	bc
		ld	c, 0Dh
		call	DOUT		; Zeichenausgabe
		ld	c, 0Ah
		call	DOUT		; Zeichenausgabe
		pop	bc
		ld	d, 40
ttyl4:		cpi
		ret	po
		jr	ttyl2

; A=2 Zeichenausgabe C
COUT:		bit	7, c		; Ascii	< 128?
		jr	z, DOUT		; Zeichenausgabe
;
;Grafikzeichenausgabe
		ld	hl, grmode	; Steuercodes f. Grafikmode
		push	bc
		call	DOUTS5
		pop	bc
		ld	hl, chrset
		xor	a
		sla	c
		sla	c
		rla
		sla	c
		rla
		ld	b, a		; BC = Offs. in Zeichentabelle
		add	hl, bc		; HL = Pos. in Zeichentabelle
		ld	b, 8		; 8 Bytes ausgeben
;
COUT1:		ld	c, (hl)
		push	bc
		call	DOUT
		pop	bc
		inc	hl
		djnz	COUT1
		ret

;------------------------------------------------------------------------------
; Zeichenausgabe 
;------------------------------------------------------------------------------

DOUT:		in	a, (PIOBD)	; Drucker bereit?
		bit	0, a
		jr	z, dout1
		jr	DOUT
dout1:		or	a
		ld	a, c
		out	(PIOAD), a	; Zeichenausgabe
		ret

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

ESC		equ	27

; Steuercodes f. Initialisierung
initc:		db ESC, '3', 24
		db ESC, 'P'

; Steuercodes f. Grafikmodus
grmode:		db ESC, '*', 4, 8, 0
		db    0

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

; Zeichensatz 8x8 Pixel, 128 Zeichen ab 80h
chrset:		equ	$
		include	v24g_zs.inc


		end
